/*
 *  NIDAQmxBaseMiscFuncs.h
 *  NIDAQmxBaseAccess
 *
 *  Created by John Weeks on 4/1/05.
 *
 */

#include "XOPStructureAlignmentTwoByte.h"

typedef struct
{
	Handle			deviceName;		// input, must be unique
	double			errorCode;
} ResetDeviceArgs;

int DAQmxBaseXOP_ResetDevice(ResetDeviceArgs *p);

typedef struct
{
	Handle *		errorInfo;		// output, must be unique
	double			errorCode;
} GetErrorInfoArgs;

int DAQmxBaseXOP_GetErrorInfo(GetErrorInfoArgs *p);

typedef struct
{
	Handle *		errorInfo;		// output, must be unique
	double			errorNumber;
	double			errorCode;
} GetIgorErrorInfoArgs;

int DAQmxBaseXOP_GetNonNIErrorInfo(GetIgorErrorInfoArgs *p);

typedef struct
{
	double			numSampsPerChan;
	double			taskNumber;
	double			errorCode;
} CfgInputBufferArgs;

int DAQmxBaseXOP_CfgInputBuffer(CfgInputBufferArgs *p);


#include "XOPStructureAlignmentReset.h"
