/*
 *  NIDAQmxBaseReadFunctions.h
 *  NIDAQmxBaseAccess
 *
 *  Created by John Weeks on 4/4/05.
 *
 */


#include "XOPStructureAlignmentTwoByte.h"
 
#include "IncludeXOPStandardHeaders.h"			// Include ANSI headers, Mac headers, IgorXOP.h, XOP.h and XOPSupport.h

typedef struct
{
	double * sampsPerChanRead;
	waveHndl dataBuffer;		// We use the wave directly as the buffer for the read; we don't need the buffer size as a parameter.
	double fillMode;			// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
	double timeout;
	double numSampsPerChan;
	double taskNumber;
	double errorCode;
} ReadAnalogDigitalWave;

int DAQmxBaseXOP_ReadAnalogF64(ReadAnalogDigitalWave *p);
int DAQmxBaseXOP_ReadBinaryI16(ReadAnalogDigitalWave *p);

typedef struct
{
	double * sampsPerChanRead;
	waveHndl dataBuffer;		// We use the wave directly as the buffer for the read; we don't need the buffer size as a parameter.
	double timeout;
	double numSampsPerChan;
	double taskNumber;
	double errorCode;
} ReadCounterWave;

int DAQmxBaseXOP_ReadCounterF64(ReadCounterWave *p);
int DAQmxBaseXOP_ReadCounterU32(ReadCounterWave *p);

int DAQmxBaseXOP_ReadDigitalU32(ReadAnalogDigitalWave *p);
int DAQmxBaseXOP_ReadDigitalU8(ReadAnalogDigitalWave *p);

typedef struct
{
	double *value;				// really a 32-bit unsigned value (it's OK- a double has 48 bits of mantissa)
	double timeout;
	double taskNumber;
	double errorCode;
} ReadScalarArgs;

int DAQmxBaseXOP_ReadCntrScalarF64(ReadScalarArgs *p);
int DAQmxBaseXOP_ReadCntrScalarU32(ReadScalarArgs *p);
int DAQmxBaseXOP_ReadDigScalarU32(ReadScalarArgs *p);


#include "XOPStructureAlignmentReset.h"
