#include "NIDAQmxBase.h"

#include "XOPStructureAlignmentTwoByte.h"

int GetTaskHandle(int tasknumber, TaskHandle &h);
void EraseTasks(void);

typedef struct
{
	double *		taskNumber;		// output: index into our own vector of task handles; pass-by-reference
	Handle			taskName;		// input, must be unique
	double			errorCode;
}CreateTaskArgs;

int DAQmxBaseXOP_CreateTask(CreateTaskArgs *p);

int DAQmxBaseXOP_LoadTask(CreateTaskArgs *p);

typedef struct
{
	double			taskNumber;		// output: index into our own vector of task handles; pass-by-reference
	double			errorCode;
}TaskNumberArgs;

int DAQmxBaseXOP_ClearTask(TaskNumberArgs *p);

int DAQmxBaseXOP_StartTask(TaskNumberArgs *p);

int DAQmxBaseXOP_StopTask(TaskNumberArgs *p);

typedef struct
{
	double *		isDone;
	double			taskNumber;		// output: index into our own vector of task handles; pass-by-reference
	double			errorCode;
}IsTaskDoneArgs;

int DAQmxBaseXOP_IsTaskDone(IsTaskDoneArgs *p);


#include "XOPStructureAlignmentReset.h"
