#include "XOPStandardHeaders.r"

resource 'vers' (1) {						/* XOP version info */
	0x01, 0x00, final, 0x00, 0,				/* version bytes and country integer */
	"1.00",
	"1.00,  2005 WaveMetrics, Inc., all rights reserved."
};

resource 'vers' (2) {						/* Igor version info */
	0x04, 0x00, release, 0x00, 0,			/* version bytes and country integer */
	"5.00",
	"(for Igor Pro 5.00 or later)"
};

resource 'XOPI' (1100) {
	XOP_VERSION,							// XOP protocol version.
	DEV_SYS_CODE,							// Development system information.
	0,										// Obsolete - set to zero.
	0,										// Obsolete - set to zero.
	XOP_TOOLKIT_VERSION,					// XOP Toolkit version.
};

resource 'XOPF' (1100) {
	{
		"DAQmxBaseXOP_CreateTask",			/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			HSTRING_TYPE,							/* task name */
			NT_FP64 | FV_REF_TYPE,			/* task handle index into our vector of task handles */
		},
		"DAQmxBaseXOP_LoadTask",			/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			HSTRING_TYPE,							/* task name */
			NT_FP64 | FV_REF_TYPE,			/* task handle index into our vector of task handles */
		},
		"DAQmxBaseXOP_ClearTask",			/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
		},
		"DAQmxBaseXOP_StartTask",			/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
		},
		"DAQmxBaseXOP_StopTask",			/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
		},
		"DAQmxBaseXOP_IsTaskDone",			/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64 | FV_REF_TYPE,			// output: 0 = no; 1 = yes;
		},
		"DAQmxBaseXOP_ResetDevice",			/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			HSTRING_TYPE,					// device name
		},
		"DAQmxBaseXOP_GetErrorInfo",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			HSTRING_TYPE | FV_REF_TYPE,		// error info output
		},
		"DAQmxBaseXOP_GetNonNIErrorInfo",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						// error number of non-NI error
			HSTRING_TYPE | FV_REF_TYPE,		// error info output
		},
		"DAQmxBaseXOP_CfgInputBuffer",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSamples
		},
		"DAQmxBaseXOPCreateAIVoltageChan",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// one of DAQmx_Val_Cfg_Default, DAQmx_Val_RSE, DAQmx_Val_NRSE or DAQmx_Val_Diff (-1, 10083, 10078, 10106)
			NT_FP64,						// minVal
			NT_FP64,						// maxVal
			NT_FP64,						// units DAQmx_Val_Volts (10348), only.
			HSTRING_TYPE,					// custom scale name (ignored)
		},
		"DAQmxBaseXOPCreateAIThrmcplChan",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// minVal
			NT_FP64,						// maxVal
			NT_FP64,						// units DAQmx_Val_DegC, DAQmx_Val_DegF, DAQmx_Val_Kelvins, DAQmx_Val_DegR (10143, 10144, 10145, 10325)
			NT_FP64,						// cjcSource one of DAQmx_Val_BuiltIn, DAQmx_Val_ConstVal, DAQmx_Val_Chan (10200, 10119, 10268)
			NT_FP64,						// cold junction temp
			HSTRING_TYPE,					// channel for cold-junction readings
		},
		"DAQmxBaseXOP_ReadAnalogF64",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// timeout
			NT_FP64,						// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
			WAVE_TYPE | NT_FP64,			// wave for data buffer
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually read
		},
		"DAQmxBaseXOP_ReadBinaryI16",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// timeout
			NT_FP64,						// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
			WAVE_TYPE | NT_FP64,			// wave for data buffer
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually read
		},
		"DAQmxBaseXOP_ReadCounterF64",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// timeout
			WAVE_TYPE | NT_FP64,			// wave for data buffer
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually read
		},
		"DAQmxBaseXOP_ReadCounterU32",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// timeout
			WAVE_TYPE | NT_FP64,			// wave for data buffer
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually read
		},
		"DAQmxBaseXOP_ReadDigitalU32",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// timeout
			NT_FP64,						// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
			WAVE_TYPE | NT_FP64,			// wave for data buffer
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually read
		},
		"DAQmxBaseXOP_ReadDigitalU8",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// timeout
			NT_FP64,						// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
			WAVE_TYPE | NT_FP64,			// wave for data buffer
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually read
		},
		"DAQmxBaseXOP_ReadCntrScalarF64",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// timeout
			NT_FP64 | FV_REF_TYPE,			// value output
		},
		"DAQmxBaseXOP_ReadCntrScalarU32",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// timeout
			NT_FP64 | FV_REF_TYPE,			// value output
		},
		"DAQmxBaseXOP_ReadDigScalarU32",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// timeout
			NT_FP64 | FV_REF_TYPE,			// value output
		},
		"DAQmxBaseXOP_CfgSampClkTiming",	/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// source- ignored except for counting edges
			NT_FP64,						// rate
			NT_FP64,						// activeEdge: DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
			NT_FP64,						// sampleMode: DAQmx_Val_FiniteSamps or DAQmx_Val_ContSamps (10178 or 10123)
			NT_FP64,						// sampsPerChanToAcquire
		},
		"DAQmxBaseXOP_CfgImplicitTiming",	/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// sampleMode: DAQmx_Val_FiniteSamps or DAQmx_Val_ContSamps (10178 or 10123)
			NT_FP64,						// sampsPerChanToAcquire
		},
		"DAQmxBaseXOPCreateAOVoltageChan",	/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// minVal
			NT_FP64,						// maxVal
			NT_FP64,						// DAQmx_Val_Volts (10348), only.
			HSTRING_TYPE,					// custom scale name (ignored)
		},
		"DAQmxBaseXOP_CreateDIChan",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec (in this case, digital I/O lines)
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// grouping DAQmx_Val_ChanForAllLines (1), only. (alternative using DAQmx is DAQmx_Val_ChanPerLine, 0).
		},
		"DAQmxBaseXOP_CreateDOChan",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec (in this case, digital I/O lines)
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// grouping DAQmx_Val_ChanForAllLines (1), only. (alternative using DAQmx is DAQmx_Val_ChanPerLine, 0).
		},
		"DAQmxBaseXOP_CreateCIPeriodChan",	/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// minVal
			NT_FP64,						// maxVal
			NT_FP64,						// DAQmx_Val_Seconds or DAQmx_Val_Ticks (10364 or 10304)
			NT_FP64,						// edge DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
			NT_FP64,						// measMethod DAQmx_Val_LowFreq1Ctr only (10105).
			NT_FP64,						// measTime (0 only)
			NT_FP64,						// divisor (1 only)
			HSTRING_TYPE,					// custom scale name (ignored)
		},
		"DAQmxBaseXOPCreateCICntEdgeChan",	/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// edge DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
			NT_FP64,						// initialCount
			NT_FP64,						// countDirection; DAQmx_Val_CountUp or DAQmx_Val_CountDown (10128 or 10124)
		},
		"DAQmxBaseXOPCreateCIPlsWdthChan",	/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// minVal
			NT_FP64,						// maxVal
			NT_FP64,						// DAQmx_Val_Seconds or DAQmx_Val_Ticks (10364 or 10304)
			NT_FP64,						// edge DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
			HSTRING_TYPE,					// custom scale name (ignored)
		},
		"DAQmxBaseXOPCreateCOPlsChanFreq",	/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// Channel spec
			HSTRING_TYPE,					// user channel name
			NT_FP64,						// units DAQmx_Val_Hz only (10373)
			NT_FP64,						// idleState DAQmx_Val_High or DAQmx_Val_Low (10192 or 10214)
			NT_FP64,						// initialDelay
			NT_FP64,						// frequency
			NT_FP64,						// dutyCycle
		},
		"DAQmxBaseXOP_DisableStartTrig",	/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
		},
		"DAQmxBaseXOP_DisableRefTrig",		/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
		},
		"DAQmxBaseXOP_CfgDigEdgeStrtTrig",	/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// trigger source
			NT_FP64,						// triggerEdge; DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
		},
		"DAQmxBaseXOP_CfgDigEdgeRefTrig",	/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// trigger source
			NT_FP64,						// triggerEdge; DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
			NT_FP64,						// pretrigger samples
		},
		"DAQmxBaseXOPCfgAnlgEdgeStrtTrig",	/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// trigger source
			NT_FP64,						// slope DAQmx_Val_RisingSlope or DAQmx_Val_FallingSlope (10280 or 10171)
			NT_FP64,						// level;
		},
		"DAQmxBaseXOP_CfgAnlgEdgeRefTrig",	/* function name */
		F_EXTERNAL,
		NT_FP64,							/* return value type */			
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			HSTRING_TYPE,					// trigger source
			NT_FP64,						// slope DAQmx_Val_RisingSlope or DAQmx_Val_FallingSlope (10280 or 10171)
			NT_FP64,						// level;
			NT_FP64,						// pretrigger samples
		},
		"DAQmxBaseXOP_WriteAnalogF64",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// autoStart
			NT_FP64,						// timeout
			NT_FP64,						// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
			WAVE_TYPE | NT_FP64,			// wave for data buffer; must be double-precision (make/D)
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually written
		},
		"DAQmxBaseXOP_WriteDigitalU8",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// autoStart
			NT_FP64,						// timeout
			NT_FP64,						// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
			WAVE_TYPE | NT_FP64,			// wave for data buffer; must be unsigned byte (make/B/U)
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually written
		},
		"DAQmxBaseXOP_WriteDigitalU32",		/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// numSampsPerChan
			NT_FP64,						// autoStart
			NT_FP64,						// timeout
			NT_FP64,						// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
			WAVE_TYPE | NT_FP64,			// wave for data buffer; must be unsigned byte (make/I/U)
			NT_FP64 | FV_REF_TYPE,			// Samples per channel actually written
		},
		"DAQmxBaseXOP_WriteDigScalarU32",	/* function name */
		F_EXTERNAL,
		NT_FP64,							// error code		
		{
			NT_FP64,						/* task handle index into our vector of task handles */
			NT_FP64,						// autoStart
			NT_FP64,						// timeout
			NT_FP64,						// value
		},
	}
};

resource 'STR#' (1100) {					/* custom error messages */
	{
		/* 1 */
		"Bad task number.",
		/* 2 */
		"This function requires a double-precision wave (use Make/D).",
		/* 3 */
		"This function requires a 16-bit integer wave (use Make/W).",
		/* 4 */
		"This function requires an 8-bit unsigned integer wave (use Make/B/U).",
		/* 5 */
		"This function requires a 32-bit unsigned integer wave (use Make/I/U).",
	}
};
