/*
 *  NIDAQmxBase_TimingFuncs.cpp
 *  NIDAQmxBaseAccess
 *
 *  Created by John Weeks on 4/4/05.
 *
 */

#include "IncludeXOPStandardHeaders.h"			// Include ANSI headers, Mac headers, IgorXOP.h, XOP.h and XOPSupport.h
#include "NIDAQmxBaseXOPMain.h"
#include "NIDAQmxBaseTaskFuncs.h"
#include "NIDAQmxBase_Utility.h"

#include "NIDAQmxBase.h"

#include "NIDAQmxBase_TimingFuncs.h"

int32 DAQmxBaseXOP_CfgSampClkTiming(SampClkTimingArgs *p)
{
	p->errorCode = 0.0;
	
	TaskHandle h;
	if ((p->errorCode = GetTaskHandle(static_cast<int>(p->taskNumber), h)) != 0.0)
		return 0;
	
	string source = WM_DAQmx::StringFromHandleAndDispose(p->source);
	int32 activeEdge = static_cast<int32>(p->activeEdge);
	int32 sampleMode = static_cast<int32>(p->sampleMode);
	uInt64 sampsPerChanToAcquire = static_cast<uInt64>(p->sampsPerChanToAcquire);

	p->errorCode = DAQmxBaseCfgSampClkTiming(h, source.c_str(), p->rate, activeEdge, sampleMode, sampsPerChanToAcquire);
	
	return 0;
}

int32 DAQmxBasXOP_CfgImplicitTiming(ImplicitTimingArgs *p)
{
	p->errorCode = 0.0;
	
	TaskHandle h;
	if ((p->errorCode = GetTaskHandle(static_cast<int>(p->taskNumber), h)) != 0.0)
		return 0;
	
	int32 sampleMode = static_cast<int32>(p->sampleMode);
	uInt64 sampsPerChanToAcquire = static_cast<uInt64>(p->sampsPerChanToAcquire);

	p->errorCode = DAQmxBaseCfgImplicitTiming(h,sampleMode, sampsPerChanToAcquire);
	
	return 0;
}
