/*
 *  NIDAQmxBase_TimingFuncs.h
 *  NIDAQmxBaseAccess
 *
 *  Created by John Weeks on 4/4/05.
 *
 */

#include "XOPStructureAlignmentTwoByte.h"

#include "IncludeXOPStandardHeaders.h"			// Include ANSI headers, Mac headers, IgorXOP.h, XOP.h and XOPSupport.h

typedef  struct
{
	double sampsPerChanToAcquire;	
	double sampleMode;		// DAQmx_Val_FiniteSamps or DAQmx_Val_ContSamps (10178 or 10123)
	double activeEdge;		// DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
	double rate;
	Handle source;
	double taskNumber;
	double errorCode;
}SampClkTimingArgs;

int32 DAQmxBaseXOP_CfgSampClkTiming(SampClkTimingArgs *p);

typedef  struct
{
	double sampsPerChanToAcquire;	
	double sampleMode;		// DAQmx_Val_FiniteSamps or DAQmx_Val_ContSamps (10178 or 10123)
	double taskNumber;
	double errorCode;
}ImplicitTimingArgs;

int32 DAQmxBasXOP_CfgImplicitTiming(ImplicitTimingArgs *p);

#include "XOPStructureAlignmentReset.h"
