/*
 *  NIDAQmxBase_TriggerFunctions.cpp
 *  NIDAQmxBaseAccess
 *
 *  Created by John Weeks on 4/5/05.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#include "IncludeXOPStandardHeaders.h"			// Include ANSI headers, Mac headers, IgorXOP.h, XOP.h and XOPSupport.h
#include "NIDAQmxBaseXOPMain.h"
#include "NIDAQmxBaseTaskFuncs.h"
#include "NIDAQmxBase_Utility.h"

#include "NIDAQmxBase.h"

#include "NIDAQmxBase_TriggerFunctions.h"

int DAQmxBaseXOP_DisableStartTrig(TaskNumberOnlyArgs *p)
{
	p->errorCode = 0.0;
	
	TaskHandle h;
	if ((p->errorCode = GetTaskHandle(static_cast<int>(p->taskNumber), h)) != 0.0)
		return 0;

	p->errorCode = DAQmxBaseDisableStartTrig(h);
	
	return 0;
}

int DAQmxBaseXOP_DisableRefTrig(TaskNumberOnlyArgs *p)
{
	p->errorCode = 0.0;
	
	TaskHandle h;
	if ((p->errorCode = GetTaskHandle(static_cast<int>(p->taskNumber), h)) != 0.0)
		return 0;

	p->errorCode = DAQmxBaseDisableRefTrig(h);
	
	return 0;
}

int DAQmxBaseXOP_CfgDigEdgeStrtTrig(DigEdgeStartTrigArgs *p)
{
	p->errorCode = 0.0;
	
	TaskHandle h;
	if ((p->errorCode = GetTaskHandle(static_cast<int>(p->taskNumber), h)) != 0.0)
		return 0;
	
	string source = WM_DAQmx::StringFromHandleAndDispose(p->source);
	int32 triggerEdge = static_cast<int32>(p->triggerEdge);

	p->errorCode = DAQmxBaseCfgDigEdgeStartTrig(h, source.c_str(), triggerEdge);
	
	return 0;
}

int DAQmxBaseXOP_CfgDigEdgeRefTrig(DigEdgeRefTrigArgs *p)
{
	p->errorCode = 0.0;
	
	TaskHandle h;
	if ((p->errorCode = GetTaskHandle(static_cast<int>(p->taskNumber), h)) != 0.0)
		return 0;
	
	string source = WM_DAQmx::StringFromHandleAndDispose(p->source);
	int32 triggerEdge = static_cast<int32>(p->triggerEdge);
	uInt32 preTrigSamples = static_cast<uInt32>(p->preTrigSamples);

	p->errorCode = DAQmxBaseCfgDigEdgeRefTrig(h, source.c_str(), triggerEdge, preTrigSamples);
	
	return 0;
}

int32 DAQmxBaseXOPCfgAnlgEdgeStrtTrig(AnalogStartTrigArgs *p)
{
	p->errorCode = 0.0;
	
	TaskHandle h;
	if ((p->errorCode = GetTaskHandle(static_cast<int>(p->taskNumber), h)) != 0.0)
		return 0;
	
	string source = WM_DAQmx::StringFromHandleAndDispose(p->source);
	int32 slope = static_cast<int32>(p->slope);

	p->errorCode = DAQmxBaseCfgAnlgEdgeStartTrig(h, source.c_str(), slope, p->level);
	
	return 0;
}

int32 DAQmxBaseXOP_CfgAnlgEdgeRefTrig(AnalogRefTrigArgs *p)
{
	p->errorCode = 0.0;
	
	TaskHandle h;
	if ((p->errorCode = GetTaskHandle(static_cast<int>(p->taskNumber), h)) != 0.0)
		return 0;
	
	string source = WM_DAQmx::StringFromHandleAndDispose(p->source);
	int32 slope = static_cast<int32>(p->slope);
	uInt32 preTrigSamples = static_cast<uInt32>(p->preTrigSamples);

	p->errorCode = DAQmxBaseCfgAnlgEdgeRefTrig(h, source.c_str(), slope, p->level, preTrigSamples);
	
	return 0;
}
