/*
 *  NIDAQmxBase_TriggerFunctions.h
 *  NIDAQmxBaseAccess
 *
 *  Created by John Weeks on 4/5/05.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#include "XOPStructureAlignmentTwoByte.h"

#include "IncludeXOPStandardHeaders.h"			// Include ANSI headers, Mac headers, IgorXOP.h, XOP.h and XOPSupport.h

typedef struct
{
	double			taskNumber;		// index into our own vector of task handles; pass-by-reference
	double			errorCode;
}TaskNumberOnlyArgs;

int DAQmxBaseXOP_DisableStartTrig(TaskNumberOnlyArgs *p);
int DAQmxBaseXOP_DisableRefTrig(TaskNumberOnlyArgs *p);

typedef struct
{
	double			triggerEdge;	// DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
	Handle			source;
	double			taskNumber;		// index into our own vector of task handles; pass-by-reference
	double			errorCode;
}DigEdgeStartTrigArgs;

int DAQmxBaseXOP_CfgDigEdgeStrtTrig(DigEdgeStartTrigArgs *p);

typedef struct
{
	double			preTrigSamples;
	double			triggerEdge;	// DAQmx_Val_Rising or DAQmx_Val_Falling (10280 or 10171)
	Handle			source;
	double			taskNumber;		// index into our own vector of task handles; pass-by-reference
	double			errorCode;
}DigEdgeRefTrigArgs;

int DAQmxBaseXOP_CfgDigEdgeRefTrig(DigEdgeRefTrigArgs *p);

typedef struct
{
	double			level;
	double			slope;			// DAQmx_Val_RisingSlope or DAQmx_Val_FallingSlope (10280 or 10171)
	Handle			source;
	double			taskNumber;		// index into our own vector of task handles; pass-by-reference
	double			errorCode;
}AnalogStartTrigArgs;

int32 DAQmxBaseXOPCfgAnlgEdgeStrtTrig(AnalogStartTrigArgs *p);

typedef struct
{
	double			preTrigSamples;
	double			level;
	double			slope;			// DAQmx_Val_RisingSlope or DAQmx_Val_FallingSlope (10280 or 10171)
	Handle			source;
	double			taskNumber;		// index into our own vector of task handles; pass-by-reference
	double			errorCode;
}AnalogRefTrigArgs;

int32 DAQmxBaseXOP_CfgAnlgEdgeRefTrig(AnalogRefTrigArgs *p);

#include "XOPStructureAlignmentReset.h"