#ifdef _WINDOWS_
#pragma pack(2)
#endif

#include <string>
#include <sstream>
#include <iomanip>
#include <vector>
#include <limits>
#include <new>
#include <algorithm>
#include <functional>
#include <list>

using std::string;
using std::vector;
using std::ostringstream;
using std::list;

#include "IncludeXOPStandardHeaders.h"			// Include ANSI headers, Mac headers, IgorXOP.h, XOP.h and XOPSupport.h

namespace WM_DAQmx
{
	// *************************
	// waves
	// *************************
#if 0	
	int GetTheWave(string &datafolderPath, string &name, waveHndl *theWave)
	{
		DataFolderHandle	currentFolderH;
		DataFolderHandle	pathFolderH;
		int	error=0;
		
		error = GetCurrentDataFolder(&currentFolderH);
		if (error)
			return error;
		
		if (datafolderPath.empty())
			pathFolderH = currentFolderH;
		else
			error = GetNamedDataFolder(currentFolderH, const_cast<char *>(datafolderPath.c_str()), &pathFolderH);
		if (error)
			return error;
			
		*theWave = FetchWaveFromDataFolder(pathFolderH, name.c_str());
		return 0;
	}
#endif	
	// *************************
	// string utility functions
	// *************************
	
	bool ciCharEqual(char c1, char c2)
	{
		return toupper(c1) == toupper(c2);
	}
	
	bool ciStringEqual(const string &s1, const string &s2)
	{
		typedef std::pair<string::const_iterator, string::const_iterator > PSCI;
		
		PSCI p = mismatch(s1.begin(), s1.end(), s2.begin(), ciCharEqual);
		if (p.first == s1.end() && p.second ==  s2.end())
			return 1;
		
		return 0;
	}
	
	int isLiberalWaveChar(int currentC)
	{
		if (iscntrl(currentC))
			return 0;
		if ((currentC == '"') ||
			(currentC == '\'') ||
			(currentC == ':') ||
			(currentC == ';'))
				return 0;
		
		return 1;
	}
	
	void PossiblyQuoteString(string &name)
	{
		char quotedName[MAX_OBJ_NAME+3];
		
		name.copy(quotedName, MAX_OBJ_NAME+2);
		quotedName[name.size()] = '\0';
		PossiblyQuoteName(quotedName);
		name.assign(quotedName);
	}

	// returns number of characters in ss after trimming whitespace from beginning and end
	long trimWSfromString(string &ss)
	{
		for (string::iterator i = ss.begin(); i != ss.end(); ++i)
		{
			if (!isspace(*i))
			{
				if (i != ss.begin())
					ss.erase(ss.begin(), i);
				break;
			}
		}
		for (string::reverse_iterator i = ss.rbegin(); i != ss.rend(); ++i)
		{
			if (!isspace(*i))
			{
				if (i != ss.rbegin())
					ss.erase(i.base(), ss.end());
				break;
			}
		}
		return ss.size();
	}
	
	// looks for cr-lf or lf and replaces with cr
	void ReplaceStringEOLwCR(string &ss)
	{
		std::string::size_type i = 0;
		while(1)
		{
			i = ss.find("\n", i);
			if (i == std::string::npos)
				break;
			
			if (ss[i-1] == '\r')
				ss.replace(i-1, i+1, "\r");
			else if (ss[i+1] == '\r')
				ss.replace(i, i+2, "\r");
			else
				ss.replace(i, i+1, "\r");
		}
	}
	
	string ReplaceCstrEOLwCR(const char *cc)
	{
		string astr(cc);
		ReplaceStringEOLwCR(astr);
		return astr;
	}
	
}


#ifdef _WINDOWS_
#pragma pack()
#endif
