/*
 *  DAQmxBase_WriteFunctions.h
 *  NIDAQmxBaseAccess
 *
 *  Created by John Weeks on 4/5/05.
 *
 */

#include "XOPStructureAlignmentTwoByte.h"

#include "IncludeXOPStandardHeaders.h"			// Include ANSI headers, Mac headers, IgorXOP.h, XOP.h and XOPSupport.h

typedef struct
{
	double *sampsPerChanWritten;
	waveHndl dataBuffer;		// a double-precision wave
	double dataLayout;			// DAQmx_Val_GroupByChannel or DAQmx_Val_GroupByScanNumber (0 or 1)
	double timeout;
	double autoStart;			// always set to FALSE (zero);
	double sampsPerChan;
	double taskNumber;
	double errorCode;
} WriteArgs;

int DAQmxBaseXOP_WriteAnalogF64(WriteArgs *p);

int DAQmxBaseXOP_WriteDigitalU8(WriteArgs *p);

int DAQmxBaseXOP_WriteDigitalU32(WriteArgs *p);

typedef struct
{
	double value;				// really a 32-bit unsigned value (it's OK- a double has 48 bits of mantissa)
	double timeout;
	double autoStart;			// always set to FALSE (zero);
	double taskNumber;
	double errorCode;
} WriteScalarArgs;

int DAQmxBaseXOP_WriteDigScalarU32(WriteScalarArgs *p);

#include "XOPStructureAlignmentReset.h"
